//---------------------------------------------------------------------------
// $Id: mutex-analysis.h,v 1.3 1998/06/03 16:52:43 diego Exp diego $
//
// Copyright (C) 1997 University of Alberta
//
// Author: Diego Novillo (diego@cs.ualberta.ca)
//
// This software is provided under the terms described in the
// "suif_copyright.h" include file.
//---------------------------------------------------------------------------
#ifndef __MUTEX_ANALYSIS_H
#define __MUTEX_ANALYSIS_H

#include <suif_copyright.h>
#include <stdio.h>

class pfg_node;
class bit_set;
class pfg;
class StrictInterval;
class VarRef_list;

DECLARE_DLIST_CLASS(bit_set_list, bit_set *);
DECLARE_DLIST_CLASS(StrictInterval_list, StrictInterval *);

//---------------------------------------------------------------------------
// class StrictInterval
//---------------------------------------------------------------------------
class StrictInterval {
protected:
    var_sym *_var;
    pfg_node *_entry;
    pfg_node *_exit;
    bit_set *_pn;
    bit_set *_px;
    bit_set *_body;
    VarDef_list *_exitRDefs;

public:
    StrictInterval(var_sym *var, pfg_node *n, bit_set *pn, pfg_node *x, bit_set *px);
    var_sym *var() const { return _var; }
    pfg_node *entry() const { return _entry; }
    pfg_node *exit() const { return _exit; }
    bit_set *pn() const { return _pn; }
    bit_set *px() const { return _px; }
    bit_set *body() const { return _body; }
    VarDef_list *exitRDefs() const { return _exitRDefs; }
    void computeExitRDefs();
    void rewritePiFunctions(StrictInterval_list *mutexStruct);
    void print(FILE *f=stdout);
};

#endif // __MUTEX_ANALYSIS_H
