//---------------------------------------------------------------------------
// $Id: cobegin.h,v 1.3 1998/06/03 16:52:36 diego Exp diego $
//
// Copyright (C) 1997 University of Alberta
//
// Author: Diego Novillo (diego@cs.ualberta.ca)
//
// This software is provided under the terms described in the
// "suif_copyright.h" include file.
//---------------------------------------------------------------------------
#ifndef	__COBEGIN_H
#define	__COBEGIN_H

#include <suif_copyright.h>

#define	COBEGIN	"__ODC_cobegin"

extern char *k_cobegin;

/* Free functions */
boolean isCobegin(tree_node *tn);
boolean isCobegin(instruction *instr);

class threadBody;

class tree_cobegin {
private:
    tree_instr *_mbr;
    tree_instr *_last;
    in_mbr *_instr;
    unsigned _numThreads;
    threadBody **_threadList;

public:
    tree_cobegin(tree_node *mbr);

    unsigned numThreads() const { return _numThreads; }
    threadBody *thread(unsigned num) const;
    void print(FILE *fp=stdout, int depth=0);
    tree_instr *first() const { return _mbr; }
    tree_instr *last() const { return _last; }
};

class threadBody {
private:
    tree_cobegin *_parent;
    unsigned _number;
    tree_node *_first;
    tree_node *_last;

public:
    threadBody(tree_cobegin *par, unsigned num, tree_node *t1, tree_node *t2)
	{ _parent = par; _first = t1; _last = t2; _number = num; }
    threadBody()
	{ _parent = 0; _number = 0; _first = _last = 0; }

    tree_cobegin *parent() const { return _parent; }
    tree_node *first() const { return _first; }
    tree_node *last() const { return _last; }
    unsigned number() const { return _number; }
    void extend(tree_node *t2) { _last = t2; }
    void print(FILE *fp=stdout, int depth=0);
};

class thread_node_iter {
private:
    tree_node_list_e *_first;
    tree_node_list_e *_last;
    tree_node_list_e *_sentinel;
    tree_node_list_e *_cur;
    tree_node_list_e *_nxt;
    boolean _rev; 

public:
    thread_node_iter(threadBody *t, boolean reverse=FALSE);

    void reset();
    tree_node *step();
    tree_node *peek();

    boolean is_empty();
};
#endif	// __COBEGIN_H
