/*  Top-level Parallel Library Include File for Odyssey */

/*  Copyright (c) 1994 Stanford University

    All rights reserved.

    Copyright (c) 1995, 1996, 1997 The President and Fellows of Harvard 
    University

    All rights reserved.

    This software is provided under the terms described in
    the "suif_copyright.h" include file.
 
    Modified by Diego Novillo (diego@cs.ualberta.ca)
*/

#include <suif_copyright.h>

#ifndef __PARLIB_H
#define __PARLIB_H

void init_par(int & /* argc */, char * /* argv */ []);
void exit_par();

/*
 *  Use a macro to include files so that they can be treated differently
 *  when compiling the library than when compiling an application.
 */

#ifdef PARLIB
#	include "cobegin.h"
#	include "doall.h"
#else
#	include <cobegin.h>
#	include <doall.h>
#endif

#endif /* __PARLIB_H */

